// timer.h

/*
   Sofie, a real time 3d engine / Copyright (C) 1997 Stephan Schiessling
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef F_TIMER
#define F_TIMER


// uses RDTSC !!!
// if your computer is not a Pentium or higher, then
// you have to comment out 
// TIMER =
// in Makefile


#ifndef CPS
// default is a Pentium 133 MHZ
#define CPS 1.0/133000000
#endif

///
class Clocks {
  public:
    ///
    unsigned long int low; /// unfortuantely  unsigned long long does not work !?
    ///
    unsigned long int high;
    //-----------------
    ///
    Clocks(void);
    ///
    set_zero(void);
    //-----------------
    ///
    friend Clocks operator+(const Clocks&,const Clocks&);
    ///
    friend Clocks operator-(const Clocks&,const Clocks&); // the first needs to be bigger!
};  

///
class Timer {
  ///
  Clocks start;
  ///
  Clocks stp;
  ///
  bool is_running;
  //-----------------
public:
  ///
  Timer (void);
  ///
  void init (void);
  ///
  Clocks get (void);
  /// get seconds
  double get_sec (void);
  ///
  void stop (void);
  ///
  void go_on (void);
};

#endif F_TIMER





